/*! *****************************************************************************
Copyright (c) 2016 Tangra Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
***************************************************************************** */
"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var transaction_common_1 = require("./transaction-common");
__export(require("./transaction-common"));
var Transaction = (function (_super) {
    __extends(Transaction, _super);
    function Transaction(nativeValue) {
        var _this = _super.call(this, nativeValue) || this;
        switch (nativeValue.transactionState) {
            case 4 /* Deferred */:
                _this.transactionState = transaction_common_1.TransactionState.Deferred;
                break;
            case 2 /* Failed */:
                _this.transactionState = transaction_common_1.TransactionState.Failed;
                break;
            case 1 /* Purchased */:
                _this.transactionState = transaction_common_1.TransactionState.Purchased;
                break;
            case 0 /* Purchasing */:
                _this.transactionState = transaction_common_1.TransactionState.Purchasing;
                break;
            case 3 /* Restored */:
                _this.transactionState = transaction_common_1.TransactionState.Restored;
                _this.originalTransaction = new Transaction(nativeValue.originalTransaction);
                break;
        }
        _this.productIdentifier = nativeValue.payment.productIdentifier;
        _this.transactionIdentifier = nativeValue.transactionIdentifier;
        if (nativeValue.transactionDate) {
            _this.transactionDate = nativeValue.transactionDate; // NSDate will automatically be bridged to date
        }
        if (nativeValue.transactionReceipt) {
            _this.transactionReceipt = nativeValue.transactionReceipt.base64EncodedStringWithOptions(1 /* Encoding64CharacterLineLength */);
        }
        return _this;
    }
    return Transaction;
}(transaction_common_1.TransactionBase));
exports.Transaction = Transaction;
